package kr.co.vividnext.sodalive.user

import io.reactivex.rxjava3.core.Single
import kr.co.vividnext.sodalive.common.ApiResponse
import kr.co.vividnext.sodalive.settings.notification.GetMemberInfoResponse
import kr.co.vividnext.sodalive.settings.notification.UpdateNotificationSettingRequest
import kr.co.vividnext.sodalive.user.find_password.ForgotPasswordRequest
import kr.co.vividnext.sodalive.user.login.LoginRequest
import kr.co.vividnext.sodalive.user.login.LoginResponse
import okhttp3.MultipartBody
import okhttp3.RequestBody
import retrofit2.http.Body
import retrofit2.http.GET
import retrofit2.http.Header
import retrofit2.http.Multipart
import retrofit2.http.POST
import retrofit2.http.Part

interface UserApi {
    @POST("/member/login")
    fun login(@Body request: LoginRequest): Single<ApiResponse<LoginResponse>>

    @POST("/member/signup")
    @Multipart
    fun signUp(
        @Part profileImage: MultipartBody.Part?,
        @Part("request") request: RequestBody
    ): Single<ApiResponse<LoginResponse>>

    @POST("/member/forgot-password")
    fun findPassword(@Body request: ForgotPasswordRequest): Single<ApiResponse<Any>>

    @GET("/member/info")
    fun getMemberInfo(
        @Header("Authorization") authHeader: String
    ): Single<ApiResponse<GetMemberInfoResponse>>

    @POST("/member/notification")
    fun updateNotificationSettings(
        @Body request: UpdateNotificationSettingRequest,
        @Header("Authorization") authHeader: String
    ): Single<ApiResponse<Any>>
}
